Subject: additional comments: draft-ietf-ldup-replica-req-06.txt

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Tue, 20 Feb 2001 16:32:08 -0800

This post provides comments in addition to my past posts.

draft-ietf-ldup-replica-req-06.txt [trimmed]:
> There are five data consistency models.
> 
> Model 1: Transactional Consistency -- Environments that exhibit all
> four of the ACID properties (Atomicity, Concurrency, Independence,
> Durability) [ACID].
> 
> Model 2: Eventual (or Transient) Consistency -- Environments where
> definite knowledge of the topology is provided through predetermined
> replication agreements.  Examples include X.500 Directories

I would like a note added here that X.500 replication model
is single master.

> Consistency models 1, 2 and 3 involve the use of prearranged
> replication agreements among servers.  The added complexity of the
> distributed 2-phase commit required for Model 1 is significant;
> therefor, model 1 will not be considered at this time. 

I would like the above sentence replaced with
  "While Model 1 is required to provide atomicity, the complexity
  of distributed 2-phase commit required for Model 1 is significant
  and, therefor, Model 1 is not to be considered at this time."

or like statement which highlights the lost capabilities of this
choice.  [note, I do not intend to re-discuss the choice, but
to clarify the pros and cons of the choice].

> Interoperability of replicas between directory servers may be limited
> by servers that implement semantics that go beyond what the LDAP access
> protocol defines.

Or optional features the protocol defines (such as subtypes).

>  Examples (not an exhaustive list) of such semantics
> include: (1) replication among directory servers with different access
> control systems/semantics may compromise directory security, and (2)
> replication among directory servers with different application trigger
> semantics may compromise directory data integrity.

I'd like to see knowledge information representation/semantics
added to this non-exhaustive list.

> 4  Requirements

I would like a section added discussing RFC 2251 statements
which imply requirements upon replicas.  In particular, the
statement regarding access controls constraints and "equally
capable" servers.

> M2.  The replication model MUST support both master-slave and multi-
> master relationships.

How about mixed relationships?  M masters and N slaves?
Is there a minimum number of masters the model must support?
More generally, are there topologies which must be supported?
Are there topologies which need not be supported?

> M4.  LDAP replication MUST encompass schema definitions, attribute
> names and values, access control information, and name space
> information.

I suggest adding "knowledge information" to this list.  I'd also
think the MUST could be a SHOULD.

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Wed, 21 Feb 2001 13:28:58 -0800

At 04:18 PM 2/21/01 -0500, Richard Huber wrote:
>We disagree with this because we don't feel that model 2 can never support
>atomicity.  For example, in single-master it should be fairly
>straightforward.

How about:
  While Model 1 is required to provide atomicity in multiple master
  replication is used, the complexity of distributed 2-phase commit
  required for Model 1 is significant and, therefor, Model 1 is not
  to be considered at this time.

---

From: Richard Huber <[email-masked]>
Date: Wed, 21 Feb 2001 16:18:49 -0500

Comments are embedded in the copy below.  Look for lines that are not quoted
with ">" or whatever.

Rick Huber

> I would like a note added here that X.500 replication model

OK.  We'll add that.

> added to this non-exhaustive list.

The reason we made it clear that this is NOT an exhaustive list is that we
were afraid that people would start adding to it.  We would strongly prefer
to not extend the list at this point.

> statement regarding access controls constraints and "equally

We have already specified that LDUP must replicate access controls (M4) and
have mentioned that security may be impacted if the replicating servers do
not share an access control model (sections 3, 5).  It's not clear what the
proposed change would add to the requirements.

> Are there topologies which need not be supported?

Well, since we discuss single-master, the minimum number of masters that must
be supported is one (hey, we have to be able to joke about SOMETHING).  More
seriously, we are not convinced that adding this sort of discussion would
change anything.  Since the definition of "slave replica" includes "Read-only
replicas may occur in both single- and multi-master systems.", mixed systems
are clearly supported by the requirements.

> think the MUST could be a SHOULD.

We feel that M4 MUST remain MUST.  Remember, these are requirements for the
LDUP model and protocol, not for a particular implementation of that
protocol.

We could live with adding "knowledge information".